select tablespace_name,
sum(obj_cnt) object_count,
sum(ini_ext) init_ext,
sum(byte)/1048576 bytesize,
(sum(byte)/1048576)- (sum(fbyte)/1048576) byteused,
sum(fbyte)/1048576 bytefree,
sum(largest)/1048576 avail,
round((sum(fbyte)/sum(byte+1))*100,2) free
from
(select tablespace_name,
0 obj_cnt,
0 ini_ext,
0 nex_ext,
0 byte,
sum(bytes) fbyte,
count(*) frags,
max(bytes) largest
from sys.dba_free_space
group by tablespace_name
union
select tablespace_name,
0, 0, 0, sum(bytes), 0, 0, 0
from sys.dba_data_files
group by tablespace_name
union
select tablespace_name, 0,
initial_extent/1024 ini_ext,
next_extent/1024 nex_ext,
0,0,0,0
from sys.dba_tablespaces
union
select tablespace_name,
count(*) obj_cnt,
0, 0, 0, 0, 0, 0
from sys.dba_segments
group by tablespace_name)
group by tablespace_name;
