-- GTKO bind combobox example
-- click the bind button in the toolbar to populate comboboxes for the ampersand placeholders
define bsnap = select to_char(snap_time, 'YYYY-MM-DD HH24:MI') from perfstat.stats$snapshot where snap_time > sysdate - 3 order by snap_id 
define esnap = select to_char(snap_time, 'YYYY-MM-DD HH24:MI') from perfstat.stats$snapshot where snap_time > sysdate - 1 order by snap_id 
define instnum  = select distinct(instance_number) from perfstat.stats$snapshot where snap_time > sysdate - 2


select 
  d.snap_id
  , to_char(s.snap_time, 'MM/DD HH24:MI') snap_time
  , round((snap_time - lag(snap_time) over (order by d.snap_id)) * 1440,0) prev_minutes
  , lio - lag(lio) over (order by d.snap_id) "LIO"
  , to_char((lio - lag(lio) over (order by d.snap_id)) /  ((snap_time - lag(snap_time) over (order by d.snap_id)) * 86400),'999,999') "LIO/Sec"
  , pio - lag(pio) over (order by d.snap_id) "PhysReads"
  , pwr - lag(pwr) over (order by d.snap_id) "PhysWrite"
  , redo - lag(redo) over (order by d.snap_id) "Redo"
  , uc - lag(uc) over (order by d.snap_id) "Calls"
from (
 select /*+ full(s) */  
  ss.snap_id
  ,max(ss.snap_time)
  ,max(decode(s.name, 'session logical reads', value, NULL)) lio
  ,max(decode(s.name, 'physical reads', value, NULL)) pio
  ,max(decode(s.name, 'physical writes', value, NULL)) pwr
  ,max(decode(s.name, 'redo size', value, NULL)) redo
  ,max(decode(s.name, 'user calls', value, NULL)) uc
 from stats$sysstat s join stats$snapshot ss on s.snap_id=ss.snap_id
 where ss.snap_time >= to_date(&bsnap, 'YYYY-MM-DD HH24:MI') 
   and ss.snap_time <= to_date(&esnap, 'YYYY-MM-DD HH24:MI') + 1/100
    and ss.instance_number = &instnum
 group by ss.snap_id
) d join stats$snapshot s on d.snap_id=s.snap_id
order by snap_id;




