#ifndef BROWSER_H
#define BROWSER_H

enum {B_TABLES=10,
      B_TABLE_HEAP=11,
      B_TABLE_IOT=12,
      B_TABLE_PARTITION=13,
      B_TABLE_SUBPARTITION=14,
      B_INDEXES=15,
      B_INDEX=16,
      B_INDEX_PARTITION=17,
      B_INDEX_SUBPARTITION=18,
      B_INDEXES_INVALID=19,
      B_VIEWS=20,
      B_VIEW=21,
      B_MVIEWS=30,
      B_MVIEW=31,
      B_MVIEW_LOGS=35,
      B_MVIEW_LOG=36,
      B_SYNONYMS=40,
      B_SYNONYM=41,
      B_PUBLIC_SYNONYMS=50,
      B_PUBLIC_SYNONYM_ALL=51,
      B_PUBLIC_SYNONYM_DBA=52,
      B_PUBLIC_SYNONYM_USER=53,
      B_PUBLIC_SYNONYM_VDOLLAR=54,
      B_PUBLIC_SYNONYM_OTHERS=55,
      B_QUEUES=60,
      B_QUEUE=61,
      B_SEQUENCES=70,
      B_SEQUENCE=71,
      B_PLSQL=80,
      B_FUNCTIONS=81,
      B_FUNCTION=82,
      B_PACKAGES=83,
      B_PACKAGE=84,
      B_PACKAGE_BODIES=85,
      B_PACKAGE_BODY=86,
      B_PROCEDURES=87,
      B_PROCEDURE=88,
      B_TRIGGERS=89,
      B_TRIGGER=90,
      B_TYPES=91,
      B_TYPE=92,
      B_TYPE_BODIES=93,
      B_TYPE_BODY=94,
      B_PLSQL_ARGUMENT=95,
      B_LINKS=96,
      B_LINK=97,
      B_CLUSTERS=98,
      B_CLUSTER=99,
      B_DIRECTORIES=100,
      B_DIRECTORY=101,
      B_LIBRARIES=102,
      B_LIBRARY=103,
      B_SCHEDULER=105,
      B_SCHEDULER_SCHEDULES=110,
      B_SCHEDULER_SCHEDULE=111,
      B_SCHEDULER_JOBS=112,
      B_SCHEDULER_JOB=113,
      B_SCHEDULER_RUNNING_JOBS=114,
      B_SCHEDULER_CHAINS=115,
      B_SCHEDULER_CHAIN=116,
      B_SCHEDULER_WINDOWS=117,
      B_SCHEDULER_WINDOW=118,
      B_SCHEDULER_PROGRAMS=119,
      B_SCHEDULER_PROGRAM=120,
      B_SCHEDULER_PROGRAM_ARG=121,
      B_LOBS=130,
      B_LOB=131,
      B_LOB_PARTITION=140,
      B_LOG_SUBPARTITION=141,
      B_RECYCLEBIN=150,
      B_RECYCLEBIN_ITEM=151,
      B_JAVA=160,
      B_JAVA_CLASSES=161,
      B_JAVA_METHODS=162,
      B_TYPE_ATTRIBUTE=170,
      B_TYPE_METHOD=171,
      B_TYPE_METHOD_ARG=172,
      B_TABLE_COLUMN=182,
      B_DBA=200,
      B_INSTANCE=201,
      B_DATABASE=202,
      B_SERVICES=203,
      B_SERVICE=204,
      B_SESSIONS=205,
      B_SESSION=206,
      B_SESSIONS_ACTIVE=207,
      B_SESSIONS_LONGOPS=208,
      B_ADVICE=240,
      B_ADVICE_DBCACHE=241,
      B_ADVICE_POOL=242,
      B_ADVICE_PGA=243,
      B_ADVICE_MTTR=244,
      B_ADVICE_RAC=245,
      B_ADVICE_STREAMS=246,
      B_ADVICE_PARTITION=247,
      B_ADVICE_SGA=248,
      B_ADVICE_PXBUFFER=249,
      B_ADVICE_JAVA=250,
      B_RESOURCE_CGS=280,
      B_RESOURCE_CG=281,
      B_RESOURCE_PLANS=290,
      B_RESOURCE_PLAN=291,
      B_SCHEMAS=300,
      B_SCHEMA=301,
      B_SCHEMA_OTHER=302,
      B_SECURITY=316,
      B_USERS=317,
      B_USER=318,
      B_ROLES=319,
      B_ROLE=320,
      B_PROFILES=321,
      B_PROFILE=322,
      B_FILES=323,
      B_CONTROLFILE=325,
      B_TABLESPACES=330,
      B_TABLESPACE=331,
      B_REDOLOGS=351,
      B_REDOLOG=352,
      B_DATAFILES=360,
      B_DATAFILE_10METRIC=361,
      B_DATAFILE_1HMETRIC=362,
      B_TEMPFILES=370,
      B_ARCHIVEDLOGS=380,
      B_RMAN=390,
      B_RMAN_CONFIG=400,
      B_RMAN_BACKUPS=402,
      B_RMAN_ALGOS=404,
      B_ASM=410,
      B_ASM_DISKGROUPS=412,
      B_ASM_DISKGROUP=411,
      B_ASM_DISK=414,
      B_ASM_FILE=416,
};

enum {BC_TYPEID,
      BC_PARTITIONED,
      BC_OWNER,
      BC_PIXBUF,
      BC_OBJECT,
      BC_OBJECT_INFO,
      BC_JUNK1,
      BC_JUNK2,
      BC_JUNK3,
      BC_JUNK4,
      BC_JUNK5};


typedef struct _browserSelection {
  GtkTreeView       *treeview;
  GtkTreeModel      *model;
  GtkTreeSelection  *sel;
  GtkTreeIter       iter;
  GtkTreeIter       iter_parent;
  GtkTreeIter       iter_grandparent;
  GtkTreeIter       iter_root;
  GtkTreePath       *path;
  GtkTreePath       *root_path;
  gchar             path_str[64];
  gchar             **path_arr;
  guint             depth;
} browserSelection;


typedef struct _browsernode {
  gint      typeid;
  gchar     *title;
  gchar     *pixbuf_name;
  gfloat    min_version;
  struct _browsernode  *child_node;
} browsernode;


void browser_free_selection(browserSelection *bs);

gboolean browser_get_selection(GtkTreeView *tv,  browserSelection *bs);

void object_browser_init(GtkTreeView *, guint);


void 
on_detailListActivated(GtkTreeView *,
		       GtkTreePath *,
		       GtkTreeViewColumn *,
		       gpointer);



void
on_dependencySelected(GtkTreeSelection *sel,
		      gpointer         data);


void
browser_copy_gtktreeview_columns(GtkTreeView   *source_view,
				 GtkTreeView   *dest_view,
				 GtkTreeIter   *dest_iter,
				 gboolean      delete,
				 ...);

#endif  /* BROWSER_H */

