#ifndef BROWSER_ACTIVATED_SQL_H
#define BROWSER_ACTIVATED_SQL_H


gchar *table_activated_sql =
"select id, par, own, img \"pxb\", name, info, mb, ts, col from (\
    select %d id,\
     decode(partitioned,'NO',0,1) par,\
     ai.owner own,\
     decode(ai.FUNCIDX_STATUS, NULL, \
            decode(ai.index_type, 'BITMAP', decode(ai.partitioned,'YES','bitmap_partition_pixbuf', 'bitmap_pixbuf'), \
                   decode(ai.partitioned,'YES','iot_partition_pixbuf','iot_pixbuf')), 'function_pixbuf') img,\
     ai.index_name name,\
     decode(ai.status, 'UNUSABLE', '<span foreground=\"red3\" weight=\"heavy\">!!</span>', NULL) || \
     decode(ac.constraint_name, NULL, NULL, '<span foreground=\"darkseagreen4\" weight=\"heavy\">PK</span>') info, \
     '--' mb, \
     tablespace_name ts, \
     NULL col,\
     rownum rn \
    from all_indexes ai left outer join all_constraints ac on ai.table_owner=ac.owner and ai.index_name=ac.index_name and ac.constraint_type='P'\
    where ai.table_owner=:p3 and ai.table_name=:p4\
    union all \
    select %d, \
     decode(subpartition_count,0,0,1),\
     table_owner,\
     decode(subpartition_count,0,'heap_pixbuf','partition_pixbuf'), \
     partition_name, \
     NULL, \
     '--', \
     tablespace_name, \
     high_value, \
     partition_position + 100 \
    from all_tab_partitions where table_owner=:p5 and table_name=:p6)\
    order by rn";

gchar *table_partition_activated_sql =
"select \
 %d, \
 0, \
 table_owner, 'heap_pixbuf' \"pxb\", \
 subpartition_name, \
 NULL, \
 '--', \
 tablespace_name \
from all_tab_subpartitions \
where table_owner=:p1 \
  and table_name=:p2 \
  and partition_name=:p3 \
order by subpartition_position";

gchar *index_activated_sql =
"select %d, \
 decode(subpartition_count,0,0,1),\
 index_owner,\
 decode(subpartition_count,0,'iot_pixbuf','iot_partition_pixbuf') \"pxb\",\
 partition_name, \
 decode(status,'UNUSABLE','<span foreground=\"red3\" weight=\"heavy\">  !!</span>',NULL),\
         '--', tablespace_name \
from all_ind_partitions where index_owner=:p1 and index_name=:p2 \
order by partition_position";

gchar *index_partition_activated_sql =
"select \
 %d, \
 0,\
 index_owner, \
 'iot_pixbuf' \"pxb\",\
 subpartition_name, \
 decode(status,'UNUSABLE','<span foreground=\"red3\" weight=\"heavy\">  !!</span>',NULL),\
 '--', num_rows, tablespace_name \
from all_ind_subpartitions \
where index_owner=:p1 \
  and index_name=:p2 \
  and partition_name=:p3\
order by subpartition_position";


gchar *mview_activated_sql =
"select %d, 0, owner, 'mview_pixbuf' \"pxb\", mview_name \
from all_mviews \
where owner=:p1 \
order by mview_name";

gchar *lob_activated_sql =
"select  \
 %d,\
  0,\
  table_owner,\
 'lob_pixbuf' \"pxb\", \
 partition_name,\
 NULL, \
 '--',\
 table_name||'.'||column_name,\
 lob_indpart_name \
from all_lob_partitions \
where table_owner=:p1 \
  and table_name=:p2 \
  and lob_name=:p3 \
order by 1";





#endif

