#ifndef BROWSER_SQL_H
#define BROWSER_SQL_H

gchar *table_detail_list_sql =
"SELECT \
 %d, \
 decode(t.subpartition_count, 0, 0, 1), \
 t.table_owner,\
 decode(t.subpartition_count,0, 'heap_pixbuf', 'partition_pixbuf') \"pxb\", \n \
 t.partition_name \"Table\", \
 t.tablespace_name \"Tablespace\",\
 t.logging \"Logging\",\
 NULL \"Degree\",\
 t.num_rows \"# Rows\",\
 t.blocks+t.empty_blocks \"Blocks\",\
 t.avg_row_len \"AvgLen\",\
 t.sample_size \"Sampled\",\
 to_char(t.last_analyzed,'MM/DD HH24:MI') \"Analyzed\",\
 t.high_value \
from all_tab_partitions t \
where t.table_owner=:p1 \
  and t.table_name=:p2 \
order by t.partition_position";

gchar *index_detail_list_sql =
"SELECT \
 %d, \
 decode(subpartition_count, 0, 0, 1), \
 index_owner,\
 decode(subpartition_count,0, 'iot_pixbuf', 'iot_partition_pixbuf') \"pxb\", \n \
 partition_name \"Table\", \
 decode(status, 'UNUSABLE', 'red4', 'black') ,\
 NULL,\
 NULL,\
 NULL,\
 compression,\
 tablespace_name, \
 initial_extent,\
 next_extent,\
 NULL,\
 logging,\
 blevel,\
 leaf_blocks,\
 distinct_keys,\
 avg_leaf_blocks_per_key,\
 avg_data_blocks_per_key,\
 clustering_factor,\
 num_rows,\
 sample_size,\
 to_char(last_analyzed, 'MM/DD HH24:MI'),\
 NULL,\
 NULL,\
 NULL,\
 buffer_pool,\
 pct_direct_access \
 from all_ind_partitions \
 where index_owner=:p1\
   and index_name=:p2 \
 order by partition_position";

gchar *column_detail_list_sql =
"select \
 'select * from \
  (select /*+ FIRST_ROWS */ d.*, rownum rnum from (select * from ' || a.owner || '.' || a.table_name || ' order by ' || \
  ltrim(sys_connect_by_path(col,','),',') || ') d where rownum <= :p1) where rnum >= :p2' columns \
  from (\
  select\
   c.owner,\
   c.table_name,\
   c.column_name col,\
   row_number() over (partition by c.constraint_name order by c.position) rn,\
   count(*) over (partition by c.constraint_name) cnt\
   from all_cons_columns c JOIN all_constraints i ON i.constraint_name = c.constraint_name\
    AND i.owner = c.owner AND i.table_name = c.table_name\
   where i.owner=:p1 and i.constraint_name=:p2\
   ) a\
 where rn = cnt\
 start with rn = 1 connect by prior table_name=table_name and prior rn = rn-1";


#endif
