#ifndef GUTIL_H
#define GUTIL_H

#include <gtk/gtk.h>
#include <glib.h>
#include "support.h"

GtkWidget* lw(gchar *);

const gchar *get_schema();

void set_schema(const gchar *);

void gtk_widget_set_font(GtkWidget *,
			 const gchar *);

void hideColumn(gchar *,
		gint);

void set_gtktreeview_column_names(GtkTreeView *,
				  ...);

void hide_gtktreeview_column(GtkTreeView *,
			     gint);

void expand_at_iter(GtkTreeView *,
		    GtkTreeIter *);

void setLabel(gchar *,
	      gchar *);

void delcolumn(gpointer *,
	       gpointer *);

void clear_gtktreeview(GtkTreeView *);

void clear_gtktextbuffer(GtkTextBuffer *);

void pop_results();

void popdown_results();

void clearList(GtkTreeView *);

GtkTextBuffer *getCurrentSqlBuffer(int);

char* getCommandText(int);

gchar *getComboSelected(char *);

gchar *getSchema();

gchar *getSelected(char *,
		   int);

gboolean gtk_treeview_get_value_gint(const gchar *,
				     int,
				     gint *);
gboolean gtk_treeview_get_value_gint64(const gchar *,
				       int,
				       gint64 *);

gboolean gtk_treeview_get_value_gint(const gchar *,
				     int,
				     gint *);

GList *getSelectedMulti(char *,
			int);

GtkTextView *getCurrentTextView();

GtkWidget *get_current_page();

void text_buffer_clear();

GArray *g_strsplit_garray(const gchar *,
			  const gchar *,
			  gint);

void g_strsplit_garray_free(GArray *);

#endif

