#ifndef QUERY_H
#define QUERY_H

typedef struct colData_ {
	char *colname;
	sb2 dtype;
	OCIDefine *defnp;
	char *value;
	ub2 valuelen;
	sb2 *indp;
	int progress;
	OCITypeCode typecode;
	gchar typename[128];
	OCIRef *type_ref;
	OCIType *m_type;
	sb2 *obj_col_ind;
	dvoid *type_data;
	OCIRaw *raw_value;
} colData;


typedef struct qCommand_ {
	OCIStmt *sth;
	gchar *sql;
	guint offset;
	guint len;
	GtkTreeView *target;
	GtkTextBuffer *buffer;
	void *post;
	gint op;
	GtkWidget *page;
} qCommand;


qCommand *alloc_qCommand(gchar *);

void execute_sql(const gchar *, gchar *, ...);
void execute_sql_at_iter(const gchar *, GtkTreeView *, GtkTreeIter *, ...);
void execute_sql_gtktreeview(const gchar  *, GtkTreeView  *, ...);
void execute_sql_pivotted(const gchar *, GtkTreeView *, GtkTreeIter *, gint, ...);
GList *execute_sql_to_glist(const gchar *, ...);
void free_column_node(gpointer *, gpointer *);
void output_rows(GtkTreeStore *, GtkTreeIter *, GtkTreeIter *, GSList *, guint, GIOChannel *);
void query_create_pixbufs();
GdkPixbuf *query_get_pixbuf(const gchar *);
void query_mark_error(OCIStmt *, OCIError *, GtkTextBuffer *, guint, guint);
void query_start_interface_update(const gchar *, GtkWidget *);
void query_error_interface_update(qCommand *, OCIError *, sword);
void query_select_interface_update();
void query_finish_interface_update(OCIEnv *, OCIError *, OCISvcCtx *, ub2, gint, gdouble);
GString *oci_piecewise_fetch_to_gstring(OCIStmt *);
gint query_sort_column_as_gint64(GtkTreeModel *, GtkTreeIter *, GtkTreeIter *, gpointer);
void on_display_browser_sql_window_activate (GtkMenuItem *, gpointer);

#endif
